' $APPTYPE GUI
$OPTIMIZE on 
$INCLUDE "RAPIDQ.INC"                

' Declarations (like at customs)
Declare Sub FPSChange (Sender As QComboBox)
Declare SUB BPMChange
Declare Sub CalcStuff
Declare SUB CalcButt (Sender as QButton)
Declare Sub ResetValues
Declare Sub AboutInfo
Declare Sub EndProgram
Declare Sub UsageReadme
' New tap subs
Declare sub MillsOver
Declare Sub SecsOver
Declare Sub KeyPressed (Key as Byte)
declare sub TallyEmUp
declare sub MakeTapWin
declare sub killtap
' New BPM Metronome Play subs
declare sub playtick
declare sub MetToggle

Dim font as QFont
DIM BPM# as integer
DIM FPS# as Double
DIM BPS# as Double
DIM FPM# as Double
DIM FPB# as Double
DIM FPSFormat$ as String
' New tap vars
dim num& as integer
dim tot& as integer
dim avg& as integer
Dim Time&(8) as integer
dim Mill& as integer
dim Sec& as integer
dim space& as integer
dim tap& as integer
dim tapBPM& as integer
dim Distance&(8) as double
dim Milltime AS QTimer
dim Sectime AS QTimer
dim tapForm AS QFORM
dim SecLabel AS QLABEL
dim MillLabel AS QLABEL
Dim CanLabel AS QLabel
Dim AccLabel AS QLabel
Dim SpaLabel as QLabel
Dim PressLabel as QLabel

' New BPM Metronome Play Var
dim MetOn& as integer

' The main proc
Font.Name = "Arial"
Font.Size = 8

' Create the new BPM Metronome timer
create MetTimer as qtimer
	enabled = 0
	Interval = 500
end create
' Create the app
Create Form as QForm
	Caption = "Frames and Beats Calculator"
	Width = 450
	Height = 200
	Top = 50
	left = 50
	BorderStyle = bsSingle
	ShowHint = true
' Create Menu
	Create MainMenu as QMainMenu
		Create mExit as QMenuItem
			Caption = "&Main"
			Create mGONOW as QMenuItem
				Caption = "&Exit"
				onClick = EndProgram
			end create
			Create Reset as QMenuItem
				Caption = "&Reset"
				onClick = ResetValues
			end create
		End Create
		Create mHelp as QMenuItem
			Caption = "&Help"
			Create mUsage as QMenuItem
				Caption = "&Usage"
				onClick = UsageReadme
			end create
			Create mAbout as QMenuItem
				Caption = "&About"
				onClick = AboutInfo
			end create
		End Create
	End Create 
' Create Statusbar
	Create Status as QStatusBar   
		SizeGrip = False
		ShowHint = 1
		hint = "Selected Values"

		AddPanels _
			TIME$, "Thanks for using this on " + Environ$("OS") + ".",Date$
		Panel(0).width = 75
		panel(0).alignment = 2
		Panel(1).width = 250
		panel(1).alignment = 2
		Panel(2).width = 75
		Panel(2).alignment = 2
	End Create
' Create FPM Value Label
	Create FPMValue as Qlabel
		Left = 10
		top = 45
		hint = " Calculated Frames per Minute"
		font = font
		Caption = _
			"(c) May 2000 Bryn 'BadMonkey' Mosher (bdmnky@hotmail.com)"
	End Create
' Create FPB Value Label
	Create FPBValue as QLabel
		Left = 10
		top = 75
		hint = "Calculated Frames per Beat"
		font = font
		Caption =  _
			"V1.2 Compiled using RapidQ Freeware BASIC Compiler"
	End Create
' Create BPS Value Label
	Create BPSValue as QLABEL
		Left = 10
		top = 105
		hint = "Calculated Beats Per Second"
		font = font
		Caption =  _
			"http://www.basicguru.com/abc/rapidq/"
	End Create
' Create FPS Combo Box Label
	Create FPSLabel AS QLABEL
		Caption = "FPS"
		Left = 75
		Top = 15
		Transparent = 1
	END CREATE
' Create FPS Combo Box
	CREATE FPSCombo AS QCOMBOBOX
	' Frame Rate Picker
	AddItems "15", _
		"23.976", _
		"24", _
		"25", _
		"29.976", _
		"30", _
		"59.94", _
		"60"
		Left = 10
		Top = 10
		Width = 58
		hint = "Select Frames per Second"
		OnChange = FPSChange
	END CREATE
' Create BPM Slider
	CREATE BPMslide AS QTrackBar
		left = 100
		Height = 20
		top = 10
		min = 1
		max = 256
		frequency = 25
		position = 120
		hint = "Select Beats per Minute"
		onchange = BPMChange
		END CREATE
' Create BPM Slider Label
	CREATE BPMLabel AS QLABEL
		Caption = "120 BPM"
		Left = 250
		Top = 15
		width=50
		Transparent = 1
	END CREATE
' Create Calulate Button
	CREATE CalcButton AS QBUTTON
		Caption = "Calculate"
		Left = 350
		Top = 10
		width = 60
		Hint = "Calulate Values"
		OnClick = CalcButt
	END CREATE
' Create Tap Button
	CREATE TapButton AS QBUTTON
		Caption = "Tap BPM"
		Left = 350
		Top = 50
		width = 60
		Hint = "Tap to find the BPM"
		OnClick = maketapwin
	END CREATE
' Create BPM Metronome Playback button
	create MetButt as qbutton
		Caption = "Play BPM"
		Left = 350
		Top = 90
		width = 60
		onclick = MetToggle
		parent = form
	end create
ShowModal
End Create

' Subroutines (not naval dancing)
SUB FPSChange (Sender AS QCOMBOBOX)
' detect a new frame rate from combo box
	
	select case fpscombo.text
		case	"15"
			fps# = 15
			FPSFormat$ = "AVI"
		Case "23.976"
			FPS# = 23.976
			FPSFormat$ = "HDTV (Converted from NTSC - resolution down)"
		Case "24"
			fps# = 24
			FPSFormat$ = "Film"
		case "25"
			fps# = 25
			FPSFOrmat$ = "PAL"
		case "29.976"
			fps# = 29.976
			FPSFormat$ = "NTSC"
		case "59.94"
			fps# = 59.94
			FPSFormat$ = "HDTV (Converted from NTSC - resolution up)"
		case "60"
			fps# = 60
			FPSFormat$ = "HDTV"
		case else
			fps# = 30
			FPSFormat$ = "MPEG"
	end select
	Status.Panel(0).caption = str$(FPS#) + " FPS"
	status.panel(1).caption = FPSFormat$
End Sub

SUB BPMChange
' Detect BPM change
	BPM# = BPMSlide.position
	BPMLabel.caption = str$(BPM#) + " BPM"
	Status.panel(2).caption = str$(BPM#) + " BPM"
' Update the new Metronome
	MetTimer.Interval = 1000 / (bpm# / 60)
end sub

SUB CalcButt
' So you want some numbers...
' Initialize vars
	if bpm# = 0 then
		bpm#=120
		Status.panel(2).caption = str$(BPM#) + " BPM"
	end if
	if FPSFormat$ = "" Then
		FPSFormat$ = "MPEG"
		status.panel(1).caption = FPSFormat$ + " ( Default format! )
	end if
	if FPS# = 0 then
		FPS# = 30
		Status.Panel(0).caption = str$(FPS#) + " FPS"
	end if
	call Calcstuff
end sub

Sub CalcStuff
' Calculate BPS FPM and FPB
	bps# = (bpm#/60)
	fpm# = (fps#*60)
	fpb# = (fpm#/bpm#)
	Font.size = 12
	FPBValue.font = font
	FPBValue.caption = "FPB: " + str$(fpb#)
	FPMValue.font = font
	FPMValue.caption = "FPM: " + str$(fpm#)
	BPSValue.font = font
	BPSValue.caption = "BPS: " + str$(bps#)
End Sub

sub ResetValues
' Reset to default Values
	bpmslide.position = 120
	call BPMChange
	FPSFormat$ = "MPEG"
	status.panel(1).caption = FPSFormat$ + " ( Default format! )
	FPS# = 30
	Status.Panel(0).caption = str$(FPS#) + " FPS"
	fpscombo.itemIndex = 5
	FPMValue.Caption = "All"
	FPBValue.Caption =  "Values"
	BPSValue.Caption =  "Reset"
End sub

Sub AboutInfo
	font.size = 8
	FPMValue.font = Font
	FPMValue.Caption = _
		"(c) May 2000 Bryn 'BadMonkey' Mosher (bdmnky@hotmail.com)"
	FPBValue.font = font
	FPBValue.Caption =  _
		"V1.2 Compiled using RapidQ Freeware BASIC Compiler"
	BPSValue.Font = Font
	BPSValue.Caption =  _
		"http://www.basicguru.com/abc/rapidq/"
End sub

Sub UsageReadme
	RUN "Notepad.exe Frames_n_Beats.txt"
End Sub

Sub EndProgram
' go now
	Form.Close
End Sub  

Sub MakeTapWin
' New tap sub
' Create the new window and use it
	' clear our vars
	for I = 1 to 8
      	Time&(I) = 0 
		Distance&(I) = 0
	next
	Sec& = 0
	num& = 0
	tot& = 0
	avg& = 0
	Mill& = 0
	tap& = 1
	space&=1
	' Stop the Metronome
	if MetOn& = 1 then
		call MetToggle
	end if
	' make timers
	Milltime.Interval = 10
	Milltime.Enabled = 1          ' True
	Milltime.OnTimer = MillsOver
	Sectime.Interval = 1000
	Sectime.Enabled = 1          ' True
	Sectime.OnTimer = SecsOver
	' make window
	tapform.borderstyle = bsDialog
	tapForm.OnKeyPress = KeyPressed
	tapForm.CAPTION = "Tap BPM"
	tapForm.WIDTH = 150
	tapForm.HEIGHT = 150
	tapform.left = form.left + 325
	tapform.top = form.top + 25
	tapform.parent = form
	' make seconds label
	SecLabel.Left = 10
	SecLabel.Top = 10
	Seclabel.width = 30
	Seclabel.alignment = 2
	SecLabel.Parent = TapForm
	SecLabel.Caption = STR$(60 - Sec&)
	' make milliseconds label
	MillLabel.Left = 30
	MillLabel.Top = 10
	MillLabel.alignment = 2
	MillLabel.parent = tapform
	MillLabel.Caption = "Seconds Remaining"
	' make Spacebar label
	PressLabel.Caption = "Press ..."
	PressLabel.Top = 40
	PressLabel.width = 130
	PressLabel.left = 10
	PressLabel.parent = tapform
	' make Spacebar label
	SpaLabel.Caption = "[Space] to Tap"
	SpaLabel.Top = 60
	SpaLabel.width = 130
	SpaLabel.left = 10
	SpaLabel.parent = tapform
	' make Accept label
	AccLabel.Caption = "[A] to Accept"
	AccLabel.Top = 80
	AccLabel.width = 130
	AccLabel.left = 10
	AccLabel.parent = tapform
	' make Cancel label
	CanLabel.Caption = "[C} to Cancel"
	CanLabel.Top = 100
	CanLabel.width = 130
	CanLabel.left = 10
	CanLabel.parent = tapform
	' form prepared. now show it
	TapForm.SHOWMODAL
end sub

SUB SecsOver
' New tap sub
' keeps the seconds rolling
	Sec& = Sec& + 1
	if Sec&=61 then
		call killtap
	end if
	SecLabel.Caption = STR$(60 - Sec&)
END SUB

SUB MillsOver
' New tap sub
' keeps the milliseconds rolling
	time&(tap&) = space&
 	Mill& = Mill& + 1
	space& = space& + 1
	if Mill& = 100 then
		Mill&=0
	end if
END SUB

SUB KeyPressed (Key AS BYTE)      ' Event returns one parameter
' New tap sub
' the user pressed a key
	if UCASE$(chr$(Key))= "C" then
		call KillTap
	end if
	if UCASE$(chr$(Key))= " " then
		if tap& = 8 then
			tap& = 1
		else
			tap& = tap& + 1
		end if
	end if
	if UCASE$(chr$(Key))= "A" then
		call TallyEmUp
	end if
END SUB

Sub TallyEmUp
' New tap sub
' Kill the timers
		milltime.enabled = 0
		sectime.enabled = 0
' tally up the tap results
	num&=0
	' unelegant code follows 
		IF time&(1) > time&(8) then
		 	distance&(1) = time&(2) - Time&(1)
			else
			 	distance&(1) = 0
		end if
		IF time&(2) > time&(1) then
		 	distance&(2) = time&(3) - Time&(2)
			else
			 	distance&(2) = 0
		end if
		IF time&(3) > time&(2) then
		 	distance&(3) = time&(4) - Time&(3)
			else
			 	distance&(3) = 0
		end if
		IF time&(4) > time&(3) then
		 	distance&(4) = time&(5) - Time&(4)
			else
			 	distance&(4) = 0
		end if
		IF time&(5) > time&(4) then
		 	distance&(5) = time&(6) - Time&(5)
			else
			 	distance&(5) = 0
		end if
		IF time&(6) > time&(5) then
		 	distance&(6) = time&(7) - Time&(6)
			else
			 	distance&(6) = 0
		end if
		IF time&(7) > time&(6) then
		 	distance&(7) = time&(8) - Time&(7)
			else
			 	distance&(7) = 0
		end if
		IF time&(8) > time&(7) then
		 	distance&(8) = time&(1) - Time&(8)
			else
				distance&(8) = 0
		end if
		' cease sloppy code
		for d = 1 to 8
			if distance&(d) > 0 then 
				if distance&(d) < 150 then
					num& = num& + 1
					tot& = tot& + distance&(d)
				end if
			end if
		next
		avg& = tot& / num&
		tapbpm& = 6000 / avg&
		BPMSlide.position = tapBPM&
		call BPMChange
		tapform.close
end sub

' New BPM Metronome Subs
sub MetToggle
'Toggle metronome one and off
	meton& = Meton& + 1
	if MetOn& = 1 then
		if BPM# < 1 then
			BPM# = 120
		end if
		PlayWav("tick.wav", 1)
		MetTimer.Interval = 1000 / (bpm# / 60)
		MetTimer.Enabled = 1          
		MetTimer.OnTimer = Playtick
		MetButt.caption = "PLAYING"
	else
		MetOn&=0
		MetTimer.enabled = 0
		MetButt.Caption = "Play BPM"
	end if
end sub

sub killtap
' Close the Tap form
	tapForm.close
' Kill the timers
	milltime.enabled = 0
	sectime.enabled = 0
end sub

sub Playtick
' Play the metronome tick
	PlayWav("tick.wav", 1)    '-- 1 = background play
end sub


